<template>
	<q-card style="width:90vw;">
		<q-bar>
			<q-space />
			<div class="text-h6 q-mb-xs">History</div>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip content-class="bg-white text-primary">Close</q-tooltip>
          </q-btn>
        </q-bar>
		<q-card-section class="q-pa-md">
			<q-virtual-scroll
				type="table"
				style="max-height: 70vh;"
				:virtual-scroll-item-size="48"
				:virtual-scroll-sticky-size-start="48"
				:virtual-scroll-sticky-size-end="32"
				:items="heavyList"
				>
				<template v-slot:before>
					<thead class="thead-sticky text-left">
					<tr>
						<th v-for="col in columns" :key="'1--' + col.name">
						{{ col.name }}
						</th>
					</tr>
					</thead>
				</template>

				<template v-slot:after>
					<tfoot class="tfoot-sticky text-left">
					<tr>
						<th v-for="col in columns" :key="'2--' + col.name">
						{{ col.name }}
						</th>
					</tr>
					</tfoot>
				</template>

				<template v-slot="{ item: row, index }">
					<tr :key="index">
					<td v-for="col in columns" :key="index + '-' + col.name">
						{{ row[col.prop] }}
					</td>
					</tr>
				</template>
			</q-virtual-scroll>
		</q-card-section>
	</q-card>
</template>

<script>

import api from '../boot/backend-api';

const columns = [
	{ name: 'Id', prop: 'revisionId' },
	{ name: 'Type', prop: 'type' },
	{ name: 'Editor', prop: 'editor' },
	{ name: 'Date', prop: 'date' },
	{ name: 'Message', prop: 'msg' }
];

Object.freeze(columns);

const heavyList = [];

export default {
	name: 'history-card',
	data(){
		return {
			heavyList:[],
			columns:columns
		}
	},
	computed: {},
	mounted(){
		this.getHistory();
	},
	methods: {
		getHistory(){
			api.getHistory().then(response => { 
				this.heavyList = response.data;
				// Object.freeze(heavyList);
				// Object.freeze(columns);
			}).catch(error => { console.log(error);  });
		}
	}
}
</script>



<style lang="stylus" scoped>
.thead-sticky tr > *,
.tfoot-sticky tr > * {
  position: sticky;
  opacity: 1;
  z-index: 1;
  background: $primary;
  color: white;
}

.thead-sticky tr:last-child > * {
  top: 0;
}

.tfoot-sticky tr:first-child > * {
  bottom: 0;
}
</style>